<template>
  <div class="kit table simple">
    <div class="line title table">
      <div class="unit date-type">
        <div class="date">
          <div class="kit sorting">
            <span class="label">Дата</span>
            <span class="direction old none"/>
          </div>
        </div>
        <div class="type">
          <div class="kit sorting">
            <span class="label">Тип</span>
            <span class="direction old none"/>
          </div>
        </div>
      </div>
      <div class="unit customer">
        <div class="kit sorting">
          <span class="label">Покупатель</span>
          <span class="direction old none"/>
        </div>
        <multiselect
          v-model="values.selectCustomer"
          :options="list.selectExample"
          :multiple="true"
          :close-on-select="false"
          :clear-on-select="false"
          class="multiselect__small"
          label="name"
          track-by="id"
          id="selectCustomer"
          :allow-empty="false"
          :searchable="false"
          :show-labels="false"
          :preselect-first="false"
          placeholder="Все">
          <template
            slot="selection"
            slot-scope="{ values }">
            <span
              v-if="values.length"
              class="multiselect__single">
              {{ values.length }} выбрано
            </span>
          </template>
        </multiselect>
      </div>
      <div class="unit car">
        <div class="kit sorting">
          <span class="label">Авто/Производитель</span>
          <span class="direction old none"/>
        </div>
        <multiselect
          v-model="values.selectCar"
          :options="list.selectExample"
          :multiple="true"
          :close-on-select="false"
          :clear-on-select="false"
          class="multiselect__small"
          label="name"
          track-by="id"
          id="selectCar"
          :allow-empty="false"
          :searchable="false"
          :show-labels="false"
          :preselect-first="false"
          placeholder="Все">
          <template
            slot="selection"
            slot-scope="{ values }">
            <span
              v-if="values.length"
              class="multiselect__single">
              {{ values.length }} выбрано
            </span>
          </template>
        </multiselect>
      </div>
      <div class="unit part">
        <div class="title">Запчасти/Работы</div>
        <multiselect
          v-model="values.selectPart"
          :options="list.selectExample"
          :multiple="true"
          :close-on-select="false"
          :clear-on-select="false"
          class="multiselect__small"
          label="name"
          track-by="id"
          id="selectPart"
          :allow-empty="false"
          :searchable="false"
          :show-labels="false"
          :preselect-first="false"
          placeholder="Все">
          <template
            slot="selection"
            slot-scope="{ values }">
            <span
              v-if="values.length"
              class="multiselect__single">
              {{ values.length }} выбрано
            </span>
          </template>
        </multiselect>
      </div>
      <div class="unit price">
        <div class="kit sorting">
          <span class="label">Стоимость</span>
          <span class="direction old none"/>
        </div>
        <div class="interval">
          <div class="ui input small">
            <input
              type="text"
              placeholder="От">
          </div>
          &ndash;
          <div class="ui input small">
            <input
              type="text"
              placeholder="До">
          </div>
        </div>
      </div>
      <div class="unit status">
        <div class="kit sorting">
          <span class="label">Статус заказа</span>
          <span class="direction old none"/>
        </div>
      </div>
      <div class="unit action">
        Действие
        <div class="check">
          <div class="ui checkbox inbox">
            <input
              type="checkbox"
              name="checkbox_all"
              id="req-all">
            <label for="req-all"/>
          </div>
        </div>
      </div>
    </div>

    <div
      class="line body table"
      v-for="(item, index) in requests"
      :key="index"
      :class="{selected: selectedItems.indexOf(index) !== -1, viewed: item.isViewed}">
      <div class="unit date-type">
        <div class="date">
          <flink
            href="#"
            class="kit aqualink">{{ item.date }}
          </flink>
        </div>
        <div class="type">{{ item.type }}
          <span
            v-if="item.number"
            class="nowrap">№ {{ item.number }}</span>
        </div>
      </div>
      <div class="unit customer">
        <div class="value _flexline">
          <div class="value ellipsis">{{ item.customer.name }}</div>
          <button
            type="button"
            class="btn-chat-cloud"/>
        </div>
        <div class="value ellipsis">({{ item.customer.geo }})</div>
      </div>
      <div class="unit car">
        <div class="value _flexline">
          <img
            v-if="item.logo"
            class="logo"
            :src="item.logo">
          <div class="ellipsis">{{ item.car.mark }}&nbsp;{{ item.car.model }}&nbsp;{{ item.car.year }}</div>
        </div>
        <div
          v-if="item.car.vin"
          class="value _thin">
          VIN&nbsp;
          <flink
            href="#"
            target="_blank"
            class="kit aqualink">{{ item.car.vin }}
          </flink>
        </div>
      </div>
      <div class="unit part">
        <div class="value">{{ item.part.name }}</div>
        <div
          v-if="item.part.code"
          class="value">Артикул: {{ item.part.code }}
        </div>
        <div
          v-if="item.part.type"
          class="value">{{ item.part.type }}, {{ item.part.count }}шт.
        </div>
      </div>
      <div class="unit price">
        <div
          v-if="item.price === 0"
          class="value">
          <button class="kit aqualink">Предложить цену</button>
        </div>
        <div
          v-else-if="item.price > 0 "
          class="value">{{ item.price | spacifyNumber }} руб.
        </div>
        <div
          v-else
          class="value">Отменен
        </div>
      </div>
      <div class="unit status">
        <div class="value">{{ item.status }}</div>
      </div>
      <div class="unit action">
        <div class="btn">
          <flink
            domain="main"
            href="/cabinet/inbox/request"
            v-if="item.status === 'Отправлено'"
            class="ui button circular mini blue">Подробнее
          </flink>
          <div
            v-else
            class="ui buttons circular mini blue">
            <flink
              domain="main"
              href="/cabinet/inbox/request"
              class="ui button">Подробнее
            </flink>
            <dropdown>
              <div class="item">test1 test1</div>
              <div class="item">test2</div>
              <div class="item">test3</div>
            </dropdown>
          </div>
        </div>
        <div class="check">
          <div
            v-if="item.status !== 'Отправлено'"
            class="ui checkbox inbox">
            <input
              @change="toggleSelectedItem(index)"
              type="checkbox"
              :name="'checkbox_'+index"
              :id="'req-'+index">
            <label :for="'req-'+index"/>
          </div>
        </div>
      </div>
    </div>
  </div>

</template>

<script>
import Multiselect from 'vue-multiselect';
import Dropdown from '~/components/redesign/cabinet/dropdown';

export default {
  name: 'ResultsTableInboxRequests',
  components: {
    Dropdown,
    Multiselect,
  },
  props: {
    requests: {
      type: Array,
      default() {
        return [];
      },
    },
  },
  data() {
    return {
      isVisibleDrop: false,
      values: {},
      list: {
        selectExample: [
          {
            id: '1',
            name: '1111111',
          },
          {
            id: '2',
            name: '22222',
          },
          {
            id: '3',
            name: '33333333',
          },
        ],
      },
      selectedItems: [],
    };
  },
  methods: {
    toggleSelectedItem(index) {
      if (this.selectedItems.indexOf(index) !== -1) {
        this.selectedItems = this.selectedItems.filter(item => item !== index);
      } else {
        this.selectedItems.push(index);
      }
    },
  },
};
</script>

<style scoped lang="scss">
  .nowrap {
    white-space: nowrap;
  }

  .ellipsis {
    display: block;
    overflow: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;
  }

  .kit.aqualink {
    padding: 0;
  }

  .multiselect {
    max-width: 350px;
  }

  .kit.table.simple {
    display: flex;
    padding: 0;
    width: 100%;
    margin: 0;
    @media screen and (min-width: 981px) {
      flex-direction: column;
      flex-wrap: wrap;
      justify-content: flex-start;
      align-items: center;
      border: 1px solid #9badb9;
      border-bottom: 0;
    }
    @media screen and (max-width: 980px) {
      flex-direction: row;
      flex-wrap: wrap;
      justify-content: center;
      align-items: stretch;
    }

    .line.table {
      display: flex;
      flex-flow: row nowrap;
      align-items: stretch;
      justify-content: space-between;
      height: auto;
      width: 100%;
      padding: 0;
      @media screen and (min-width: 981px) {
        border-bottom: 1px solid #9badb9;
      }

      .unit {
        display: inline-flex;
        @media screen and (min-width: 1201px) {
          &.date-type {
            order: 1;
            width: 8.5rem;
            .date {
              width: 3.75rem;
            }
            .type {
              width: 3.75rem;
            }
          }
          &.customer {
            order: 2;
            width: 10rem;
          }
          &.car {
            order: 3;
            width: calc((100% - 47rem) / 2 - 2rem);
          }
          &.part {
            order: 4;
            width: calc((100% - 47rem) / 2 + 2rem);
          }
          &.price {
            order: 5;
            width: 10rem;
          }
          &.status {
            order: 6;
            width: 7.5rem;
          }
          &.action {
            order: 7;
            width: 11rem;
            .btn {
              width: calc(100% - 2.5rem);
            }
            .check {
              width: 2.5rem;
              font-size: 0;
              text-align: right;
              margin-left: auto;
            }
          }
        }

        @media (min-width: 981px) and (max-width: 1200px) {
          &.date-type {
            order: 1;
            width: 5rem;
            .date {
              width: 5rem;
            }
            .type {
              width: auto;
            }
          }
          &.customer {
            order: 2;
            width: 7rem;
          }
          &.car {
            order: 3;
            width: 10rem;
          }
          &.part {
            order: 4;
            width: calc((100% - 32rem) / 3 + 2rem);
          }
          &.price {
            order: 5;
            width: calc((100% - 32rem) / 3);
          }
          &.status {
            order: 6;
            width: calc((100% - 32rem) / 3 - 2rem);
          }
          &.action {
            order: 7;
            width: 10rem;
            .btn {
              width: 100%;
            }
            .check {
              width: 2.5rem;
              font-size: 0;
              text-align: right;
              margin: -0.5rem 0 0.5rem 0;
            }
          }
        }

        @media screen and (max-width: 980px) {
          width: 100%;
          &.date-type {
            order: 1;
            .date {
              order: 2;
            }
            .type {
              order: 1;
            }
          }
          &.customer {
            order: 5;
          }
          &.car {
            order: 4;
          }
          &.part {
            order: 3;
          }
          &.price {
            order: 6;
          }
          &.status {
            order: 2;
          }
          &.action {
            order: 7;
            .btn {
            }
            .check {
              width: 2.5rem;
              font-size: 0;
              text-align: right;
              margin: -0.5rem 0 0.5rem 0;
            }
          }
        }
      }
    }

    .line.title.table {
      @media screen and (max-width: 980px) {
        display: none;
      }
      @media screen and (min-width: 981px) {
        width: 100%;
        min-height: 3.125rem;
        text-align: left;
        font-size: 0.6875rem;
        font-weight: 500;
        line-height: 1.3;
        padding: 0;
        color: currentColor;
        background-color: #F4F4F4;
        .unit {
          padding: 0.5rem;
          flex-direction: column;
          flex-wrap: nowrap;
          justify-content: flex-start;
          align-items: flex-start;
          &.date-type {
            flex-direction: row;
          }
          &.action {
            flex-direction: row;
            padding-left: 1.5rem;
            .check {
              margin: 0 0 0 auto;
            }
          }
        }
        .multiselect, .interval {
          margin-top: 0.25rem;
        }
        .interval {
          display: flex;
          flex-direction: row;
          flex-wrap: nowrap;
          justify-content: space-between;
          align-items: center;
          max-width: 100%;
          .ui.input {
            max-width: 46%;
          }
        }
      }
    }

    .line.body.table {
      background-color: #ffffff;
      font-weight: 700;
      line-height: 1.3;
      @media screen and (min-width: 1201px) {
        font-size: 0.8125rem;
      }
      @media (min-width: 981px) and (max-width: 1200px) {
        font-size: 0.6875rem;
      }
      @media screen and (max-width: 980px) {
        flex-wrap: wrap;
        width: 100%;
        margin: .5rem 0;
        padding: 0;
        border-radius: .25rem;
        box-shadow: 0 1px 3px 0 #d4d4d5, 0 3px 6px 1px rgba(0, 0, 0, .15);
      }
      &.viewed {
        background-color: #fafafa;
        font-weight: 400;
      }
      &.selected {
        background-color: #f6faff;
      }
      &:hover {
        box-shadow: 0 4px 8px 0 rgba(96, 126, 146, 0.15);
        z-index: 1 !important;
      }

      .unit {
        flex-direction: column;
        align-items: flex-start;
        justify-content: center;
        color: #4a4a4a;
        @media screen and (min-width: 981px) {
          padding: 1rem 0.5rem;
        }
        @media screen and (max-width: 980px) {

        }
        .value {
          display: block;
          width: 100%;
          @media screen and (min-width: 981px) {
            + .value {
              padding-top: 0.25rem;
            }
          }
          &._thin {
            font-weight: 400 !important;
          }
          &._flexline {
            display: flex;
            flex-direction: row;
            flex-wrap: nowrap;
            justify-content: flex-start;
            align-items: center;
            width: auto;
            max-width: 100%;
          }
        }
        .logo {
          display: inline-block;
          vertical-align: middle;
          max-width: 1.5rem;
          max-height: 1.5rem;
          margin-right: 0.25rem;
        }

        &.date-type {
          flex-flow: row wrap;
          justify-content: flex-start;
          align-items: center;
          @media screen and (min-width: 981px) {
            .date {
              font-size: 0.6875rem;
            }
          }
          @media screen and (max-width: 980px) {
            width: calc(100% - 9rem);
            font-size: 0.6875rem;
            padding: 1rem 0 1rem 1rem;
            border-bottom: 1px solid #9badb9;
            .date {
              &:before {
                content: 'от';
                padding-right: 0.25rem;
              }
            }
            .type {
              padding-right: 0.25rem;
            }
          }
        }

        &.status {
          @media screen and (max-width: 980px) {
            width: 9rem;
            padding: 1rem 1rem 1rem 0;
            border-bottom: 1px solid #9badb9;
            .value {
              font-size: 0.6875rem;
              text-align: right;
              &:before {
                content: 'Статус: ';
              }
            }
          }
        }
        &.customer {
          @media screen and (min-width: 981px) {
          }
          @media screen and (max-width: 980px) {
            padding: 1rem;
            color: #9badb9;
            font-size: 0.8125rem;
            font-weight: 400;
          }
        }
        &.car {
          @media screen and (max-width: 980px) {
            font-size: 0.875rem;
            padding: 0.75rem 1rem 0.25rem 1rem;
            .value + .value {
              padding-top: 0.25rem;
            }
          }
        }
        &.part {
          @media screen and (max-width: 980px) {
            display: block;
            padding: 1rem 1rem 0 1rem;
            font-size: 0.875rem;
            .value {
              display: inline;
              width: auto;
              &:first-child {
                font-weight: 700;
              }
              &:not(:last-child):after {
                content: ',';
              }
            }
          }
        }
        &.price {
          @media screen and (max-width: 980px) {
            padding: 0 1rem 1rem 1rem;
            font-size: 1rem;
          }
        }
        &.status {

        }
        &.action {
          flex-direction: row;
          flex-wrap: wrap;
          justify-content: flex-start;
          align-items: center;
          .btn {
            width: 7rem;
          }
          .ui.button.mini.blue {
            display: flex;
            align-items: center;
            justify-content: center;
            width: 100%;
            margin: 0;
          }
          @media (min-width: 981px) and (max-width: 1200px) {
            flex-direction: column-reverse;
            align-items: flex-end;
            justify-content: center;
          }

          @media screen and (max-width: 980px) {
            .check {
              display: none;
            }
            .btn {
              width: 100%;
              .ui.buttons {
                width: 100%;
              }
              .ui.button {
                display: flex;
                justify-content: center;
                align-items: center;
                border-top-right-radius: 0;
                border-top-left-radius: 0;
                border-bottom-right-radius: 0.25rem;
                border-bottom-left-radius: 0.25rem;
                min-height: 3rem;
                font-size: 1rem;
              }
            }
          }
        }
      }
    }
  }

</style>
